<template>
  <ms-modal
    :v-model="vModel"
    size="lg"
    :id="GLOBALS.__APP_NAME__ + '-list-category-sources-modal'"
    :title="$h.capitalize($t(`${GLOBALS.__T_PREFIX__}.modals.listCategorySources.title`)) + ': ' + (category ? category.label : '')"
    :ok="ok"
    @ok="$emit('ok')"
  >
    <transition
      mode="out-in"
      enter-active-class="animated fadeIn fast"
      leave-active-class="animated fadeOut fast"
    >
      <div :id="GLOBALS.__APP_NAME__ + '-list-category-sources-modal'" v-if="showModalContent" key="modal-content">
        <ms-button
          text-align="left"
          @click.native="showAddSourceModal = !showAddSourceModal"
          inline
          class="mb-2"
        >
          <v-icon name="plus" scale="0.6"></v-icon>
          {{ $t(`${GLOBALS.__T_PREFIX__}.global.addSource`) | capitalize }}
        </ms-button>
        <div v-if="categoryFeeds.length > 0">
          <p class="text-muted">{{ $t(`${GLOBALS.__T_PREFIX__}.global.feeds`) | capitalize }} (<strong>{{ categoryFeeds.length }}</strong>):</p>
          <ul class="list-unstyled sources-list">
            <li v-for="feed in categoryFeeds" :key="feed.id" class="mb-1">
              <v-icon name="link"></v-icon>
              <span class="ml-2">
                <img :src="feedFavicon(feed.url)" class="feed-favicon"/>
                <strong>{{ feed.label }}</strong>
              </span>
              <p class="edit-button" @click="editSource(feed)">
                <v-icon name="edit"></v-icon>
                <span>{{ $t(`${GLOBALS.__T_PREFIX__}.global.edit`) | capitalize }}</span>
              </p>
              <p class="delete-button" @click="handleDelete(feed)">
                <v-icon name="times-circle"></v-icon>
                <span>{{ $t(`${GLOBALS.__T_PREFIX__}.modals.editSource.deleteSource`) | capitalize }}</span>
              </p>
            </li>
          </ul>
        </div>
        <p v-else>{{ $t(`${GLOBALS.__T_PREFIX__}.global.noFeedsMessage`) }}</p>
      </div>
      <div v-else key="modal-loading">
        <icon-basic-load width="28" height="28"/>
        <span>{{ $t("global.loading") }}</span>
      </div>
    </transition>
    <!-- Add source modal -->
    <add-source-modal
        :v-model="showAddSourceModal"
        :category="category"
        @ok="showAddSourceModal = false"
        @cancel="showAddSourceModal = false"
      />
    <!-- Confirm deleting modal -->
    <ms-modal
      :v-model="showConfirmDeleting"
      :id="GLOBALS.__APP_NAME__ + '-delete-source-modal'"
      :ok="deleteFeed"
      :ok-title="$h.capitalize($t(`global.confirm`))"
      :cancel="cancelDelete"
      :cancel-title="$h.capitalize($t(`global.cancel`))"
    >
      <p>{{ $t(`${GLOBALS.__T_PREFIX__}.modals.deleteSource.confirmDeleteMessage`) }}</p>
    </ms-modal>
    <!-- Edit source modal -->
    <edit-source-modal
      :v-model="showEditSourceModal"
      :feed="feedToEdit"
      @ok="showEditSourceModal = false"
      @cancel="showEditSourceModal = false"
    />
  </ms-modal>
</template>

<script>
import { BaseComponent } from '@/utils/'

import AddSourceModal from '@/components/elements/modals/AddSourceModal'
import EditSourceModal from '@/components/elements/modals/EditSourceModal'

export default {
  extends: BaseComponent,
  data () {
    return {
      showConfirmDeleting: false,
      showEditSourceModal: false,
      showAddSourceModal: false,
      feedToEdit: null
    }
  },
  components: {
    AddSourceModal,
    EditSourceModal
  },
  computed: {
    categoryFeeds: function () {
      const categoryId = this.category ? this.category.id : null
      return this.findFeeds({ category_id: categoryId }) // return array
    },
    showModalContent: function () {
      if (this.category) {
        return true
      } else {
        return false
      }
    }
  },
  props: {
    // V-Model: to show the modal
    vModel: {
      type: Boolean,
      default: false
    },
    // Category object
    category: Object
  },
  state: {
    MyFeedsModule: [
      'feeds'
    ]
  },
  getters: {
    MyFeedsModule: [
      'findFeeds'
    ]
  },
  actions: {
    MyFeedsModule: [
      'deleteFeeds'
    ]
  },
  mutations: {
    MyFeedsModule: [
      'SET_FEEDS'
    ]
  },
  methods: {
    ok: async function () {
      return true
    },
    handleDelete: function (feed) {
      this.feedToEdit = feed
      this.showConfirmDeleting = true
    },
    cancelDelete: function () {
      this.showConfirmDeleting = false
    },
    deleteFeed: async function () {
      this.showConfirmDeleting = false
      // Try to delete feed
      const feedId = this.feedToEdit.id
      const deleteResponse = await this.deleteFeeds({
        id: this.feedToEdit.id
      })
      // If success
      if (!(deleteResponse instanceof Error)) {
        // Clean feeds for deleted category
        const cleanedFeeds = this.feeds.reduce((array, feed) => {
          if (feed.id !== feedId) {
            array.push(feed)
          }
          return array
        }, [])
        this.SET_FEEDS(cleanedFeeds)
      }
      return true
    },
    editSource: function (feed) {
      this.feedToEdit = feed
      this.showEditSourceModal = true
    },
    feedFavicon: function (url) {
      return this.$h.getHostHttpUrl(url) + '/favicon.ico'
    }
  }
}
</script>
